function [erro,modulo,fase] = Fts(Y,arq,s,Zseq,Zinmin,LB,UB,RL,modG,modHseq,fasHseq,W,P0)

X = 0.5*(UB + LB) + 0.5*(UB - LB).*sin(Y);

switch arq
case 'PB06'
    ZL1 = RL + s*X(1);
    Hc = Zseq./(Zseq+ZL1);
case 'PB12'
    ZL1 = RL + s*X(1);
    ZC1 = 1./(s*X(2));
    Hc = ( (Zseq.*ZC1)./(Zseq+ZC1) ) ./ ( (Zseq.*ZC1)./(Zseq+ZC1) + ZL1 );
case 'PB18'
    ZL1 = RL(1) + s*X(1);
    ZL2 = RL(2) + s*X(2);
    ZC1 = 1./(s*X(3));
    Hc = (Zseq.*ZC1)./((Zseq+ZL2).*ZC1 + ZL1.*(Zseq+ZL2+ZC1));
case 'PB24'
    ZL1 = RL(1) + s*X(1);
    ZL2 = RL(2) + s*X(2);
    ZC1 = 1./(s*X(3));
    ZC2 = 1./(s*X(4));
    Hc = (Zseq.*ZC1.*ZC2)./((Zseq+ZC2).*(ZC1.*ZL2 + ZL1.*ZL2 + ZL1.*ZC1) + Zseq.*ZC2.*ZL1 + Zseq.*ZC1.*ZC2);
case 'PA06'
    Ra = X(1);
    ZC1 = 1./(s*X(2));
    Hc = Zseq./(Zseq+Ra+ZC1);
case 'PA12'
    Ra = X(1);
    ZL1 = RL + s*X(2);
    ZC1 = 1./(s*X(3));
    Hc = (Zseq.*ZL1)./(Zseq.*ZL1 + ZC1.*(Zseq+ZL1) );
    Hc = (Zseq.*ZL1)./(ZL1.*(Ra+Zseq) + ZC1.*(Ra+Zseq+ZL1));
case 'PA18'
    Ra = X(1);
    ZL1 = RL + s*X(2);
    ZC1 = 1./(s*X(3));
    ZC2 = 1./(s*X(4));
    Hc = (Zseq.*ZL1)./(ZL1.*(Ra+Zseq+ZC2) + ZC1.*(Ra+Zseq+ZC2+ZL1));
case 'PA24'
    Ra = X(1);
    ZL1 = RL(1) + s*X(2);
    ZL2 = RL(2) + s*X(3);
    ZC1 = 1./(s*X(4));
    ZC2 = 1./(s*X(5));
    Hc = (Zseq.*ZL1.*ZL2)./((Ra+Zseq+ZL2).*(ZL1.*ZC2 + ZC1.*ZC2 + ZC1.*ZL1) + (Ra+Zseq).*(ZL2.*ZC1 + ZL1.*ZL2));
case 'PF06'
    Ra = X(1);
    ZL1 = RL + s*X(2);
    ZC1 = 1./(s*X(3));
    Hc = Zseq./(ZL1 + ZC1 + Ra + Zseq);
case 'PF12'
    Ra = X(1);
    ZL1 = RL(1) + s*X(2);
    ZL2 = RL(2) + s*X(3);
    ZC1 = 1./(s*X(4));
    ZC2 = 1./(s*X(5));
    Hc = (ZL2.*ZC2.*Zseq)./((Ra+Zseq).*(ZL2.*ZC2 + (ZL1+ZC1).*(ZL2+ZC2)) + ZL2.*ZC2.*(ZL1+ZC1));
case 'PF18'
    Ra = X(1);
    ZL1 = RL(1) + s*X(2);
    ZL2 = RL(2) + s*X(3);
    ZL3 = RL(3) + s*X(4);
    ZC1 = 1./(s*X(5));
    ZC2 = 1./(s*X(6));
    ZC3 = 1./(s*X(7));
    D = ZC2.*(ZL3+ZC3+Ra+Zseq) + ZL2.*(ZL3+ZC3+Ra+Zseq) + ZL2.*ZC2;
    Hc = (ZL2.*ZC2.*Zseq)./((ZL1+ZC1).*(ZC2.*(ZL3+ZC3+Ra+Zseq) + ZL2.*(ZL3+ZC3+Ra+Zseq) + ZL2.*ZC2) + ZL2.*ZC2.*(ZL3+ZC3+Ra+Zseq));
case 'PF24'
    Ra = X(1);
    ZL1 = RL(1) + s*X(2);
    ZL2 = RL(2) + s*X(3);
    ZL3 = RL(3) + s*X(4);
    ZL4 = RL(4) + s*X(5);
    ZC1 = 1./(s*X(6));
    ZC2 = 1./(s*X(7));
    ZC3 = 1./(s*X(8));
    ZC4 = 1./(s*X(9));
    Hc = Zseq.*ZL2.*ZC2.*ZL4.*ZC4./(ZL2.*ZC2.*ZC3.*ZL4.*Ra+ZL2.*ZC2.*ZC3.*ZL4.*ZC4+ZL2.*ZC2.*ZL3.*ZC4.*Ra+ZL2.*ZC2.*ZL3.*ZL4.*Ra+ZL2.*ZC2.*ZL3.*ZL4.*ZC4+ZL2.*ZC2.*ZL4.*ZC4.*Ra+ZL2.*ZC2.*ZC3.*ZC4.*Ra+ZC1.*ZC2.*ZL3.*ZL4.*Ra+ZC1.*ZC2.*ZL3.*ZL4.*ZC4+ZC1.*ZC2.*ZL4.*ZC4.*Ra+ZC1.*ZC2.*ZC3.*ZC4.*Ra+ZC1.*ZL2.*ZC2.*ZC4.*Ra+ZC1.*ZL2.*ZC2.*ZL4.*Ra+ZC1.*ZL2.*ZC2.*ZL4.*ZC4+ZC1.*ZL2.*ZL4.*ZC4.*Ra+ZC1.*ZL2.*ZC3.*ZC4.*Ra+ZC1.*ZL2.*ZC3.*ZL4.*Ra+ZC1.*ZC2.*ZC3.*ZL4.*Ra+ZC1.*ZC2.*ZC3.*ZL4.*ZC4+ZC1.*ZC2.*ZL3.*ZC4.*Ra+ZL1.*ZC2.*ZL4.*ZC4.*Ra+ZL1.*ZC2.*ZC3.*ZC4.*Ra+ZC1.*ZL2.*ZC3.*ZL4.*ZC4+ZC1.*ZL2.*ZL3.*ZC4.*Ra+ZC1.*ZL2.*ZL3.*ZL4.*Ra+ZC1.*ZL2.*ZL3.*ZL4.*ZC4+ZL1.*ZL2.*ZC3.*ZC4.*Ra+ZL1.*ZL2.*ZC3.*ZL4.*Ra+ZL1.*ZC2.*ZC3.*ZL4.*Ra+ZL1.*ZC2.*ZC3.*ZL4.*ZC4+ZL1.*ZC2.*ZL3.*ZC4.*Ra+ZL1.*ZC2.*ZL3.*ZL4.*Ra+ZL1.*ZC2.*ZL3.*ZL4.*ZC4+ZL1.*ZL2.*ZC3.*ZL4.*ZC4+ZL1.*ZL2.*ZL3.*ZC4.*Ra+ZL1.*ZL2.*ZL3.*ZL4.*Ra+ZL1.*ZL2.*ZL3.*ZL4.*ZC4+ZL1.*ZL2.*ZC2.*ZC4.*Ra+ZL1.*ZL2.*ZC2.*ZL4.*Ra+ZL1.*ZL2.*ZC2.*ZL4.*ZC4+ZL1.*ZL2.*ZL4.*ZC4.*Ra+(ZL2.*ZC2.*ZL4.*ZC4+ZL1.*ZC2.*ZC3.*ZL4+ZL1.*ZC2.*ZL3.*ZL4+ZL1.*ZL2.*ZC2.*ZL4+ZL2.*ZC2.*ZC3.*ZL4+ZL2.*ZC2.*ZL3.*ZL4+ZC1.*ZC2.*ZL3.*ZL4+ZC1.*ZC2.*ZC3.*ZL4+ZC1.*ZL2.*ZC2.*ZL4+ZC1.*ZL2.*ZL3.*ZL4+ZC1.*ZL2.*ZC3.*ZL4+ZL1.*ZL2.*ZC2.*ZC4+ZL2.*ZC2.*ZC3.*ZC4+ZL2.*ZC2.*ZL3.*ZC4+ZC1.*ZC2.*ZL3.*ZC4+ZC1.*ZL2.*ZC2.*ZC4+ZC1.*ZL2.*ZL3.*ZC4+ZC1.*ZC2.*ZC3.*ZC4+ZC1.*ZL2.*ZC3.*ZC4+ZL1.*ZL2.*ZC3.*ZC4+ZL1.*ZL2.*ZL3.*ZC4+ZL1.*ZC2.*ZC3.*ZC4+ZL1.*ZC2.*ZL3.*ZC4+ZL1.*ZL2.*ZC3.*ZL4+ZL1.*ZL2.*ZL3.*ZL4+ZC1.*ZC2.*ZL4.*ZC4+ZL1.*ZC2.*ZL4.*ZC4+ZC1.*ZL2.*ZL4.*ZC4+ZL1.*ZL2.*ZL4.*ZC4).*Zseq);
end

modHc = abs(Hc);
fasHc = angle(Hc);
modH  = (1/P0)*modHc.*modHseq;
temp = (modG - modH).^2;
erro = sum(W.*temp);
modulo = modHc.*modHseq;
if isempty(fasHseq)
    fase = [];
else
    fase = unwrap(fasHc + fasHseq);
end