function [C,Ceq,minimoZin,modZin,fasZin] = Zins(Y,arq,s,Zseq,Zinmin,LB,UB,RL,modG,modHseq,fasHseq,W,P0)

X = 0.5*(UB + LB) + 0.5*(UB - LB).*sin(Y);

switch arq
case 'PB06'
    ZL1 = RL + s*X(1);
    Zin = ZL1 + Zseq;
case 'PB12'
    ZL1 = RL + s*X(1);
    ZC1 = 1./(s*X(2));
    Zin = ZL1 + ((Zseq.*ZC1)./(Zseq+ZC1));
case 'PB18'
    ZL1 = RL(1) + s*X(1);
    ZL2 = RL(2) + s*X(2);
    ZC1 = 1./(s*X(3));
    Zin = ((Zseq+ZL2).*ZC1 + ZL1.*(Zseq+ZL2+ZC1))./(Zseq+ZL2+ZC1);
case 'PB24'
    ZL1 = RL(1) + s*X(1);
    ZL2 = RL(2) + s*X(2);
    ZC1 = 1./(s*X(3));
    ZC2 = 1./(s*X(4));
    num = (Zseq+ZC2).*(ZC1.*ZL2+ZL1.*ZL2+ZL1.*ZC1) + Zseq.*ZC1.*ZC2 + Zseq.*ZC2.*ZL1;
    den = (Zseq+ZC2).*(ZC1+ZL2) + Zseq.*ZC2;
    Zin = num./den;
case 'PA06'
    Ra = X(1);
    ZC1 = 1./(s*X(2));
    Zin = Ra + ZC1 + Zseq;
case 'PA12'
    Ra = X(1);
    ZL1 = RL + s*X(2);
    ZC1 = 1./(s*X(3));
    Zin = (ZC1.*(Ra+Zseq+ZL1) + ZL1.*(Ra+Zseq))./(Ra+Zseq+ZL1);
case 'PA18'
    Ra = X(1);
    ZL1 = RL + s*X(2);
    ZC1 = 1./(s*X(3));
    ZC2 = 1./(s*X(4));
    Zin = (ZL1.*(Ra+Zseq+ZC2) + ZC1.*(Ra+Zseq+ZC2+ZL1))./(Ra+Zseq+ZC2+ZL1);
case 'PA24'
    Ra = X(1);
    ZL1 = RL(1) + s*X(2);
    ZL2 = RL(2) + s*X(3);
    ZC1 = 1./(s*X(4));
    ZC2 = 1./(s*X(5));
    num = (Ra+Zseq+ZL2).*(ZL1.*ZC2+ZC1.*ZC2+ZC1.*ZL1) + (Ra+Zseq).*(ZL1.*ZL2+ZC1.*ZL2);
    den = (Ra+Zseq+ZL2).*(ZL1+ZC2) + ZL2.*(Ra+Zseq);
    Zin = num./den;
case 'PF06'
    Ra = X(1);
    ZL1 = RL + s*X(2);
    ZC1 = 1./(s*X(3));
    Zin = ZL1 + ZC1 + Ra + Zseq;
case 'PF12'
    Ra = X(1);
    ZL1 = RL(1) + s*X(2);
    ZL2 = RL(2) + s*X(3);
    ZC1 = 1./(s*X(4));
    ZC2 = 1./(s*X(5));
    num = (ZL1+ZC1).*(ZL2.*ZC2 + (Ra+Zseq).*(ZL2+ZC2)) + ZL2.*ZC2.*(Ra+Zseq);
    den = ZL2.*ZC2 + (Ra+Zseq).*(ZL2+ZC2);
    Zin = num./den;
case 'PF18'
    Ra = X(1);
    ZL1 = RL(1) + s*X(2);
    ZL2 = RL(2) + s*X(3);
    ZL3 = RL(3) + s*X(4);
    ZC1 = 1./(s*X(5));
    ZC2 = 1./(s*X(6));
    ZC3 = 1./(s*X(7));
    Zin = 1./((ZL2+ZC2).*Zseq+ZL2.*ZC2+ZL2.*ZL3+ZL2.*ZC3+ZL2.*Ra+ZC2.*ZL3+ZC2.*ZC3+ZC2.*Ra).*((ZL1.*ZC2+ZC1.*ZL2+ZC1.*ZC2+ZL1.*ZL2+ZL2.*ZC2).*Zseq+ZC1.*ZL2.*ZC2+ZL2.*ZC2.*ZL3+ZL2.*ZC2.*Ra+ZL1.*ZL2.*ZC2+ZL1.*ZL2.*ZL3+ZL1.*ZL2.*ZC3+ZL1.*ZL2.*Ra+ZL2.*ZC2.*ZC3+ZL1.*ZC2.*ZL3+ZL1.*ZC2.*ZC3+ZL1.*ZC2.*Ra+ZC1.*ZL2.*ZL3+ZC1.*ZL2.*ZC3+ZC1.*ZL2.*Ra+ZC1.*ZC2.*ZL3+ZC1.*ZC2.*ZC3+ZC1.*ZC2.*Ra);
case 'PF24'
    Ra = X(1);
    ZL1 = RL(1) + s*X(2);
    ZL2 = RL(2) + s*X(3);
    ZL3 = RL(3) + s*X(4);
    ZL4 = RL(4) + s*X(5);
    ZC1 = 1./(s*X(6));
    ZC2 = 1./(s*X(7));
    ZC3 = 1./(s*X(8));
    ZC4 = 1./(s*X(9));
    Zin = 1./((ZL2.*ZL3.*ZC4+ZL2.*ZL3.*ZL4+ZL2.*ZC2.*ZC4+ZL2.*ZC2.*ZL4+ZL2.*ZL4.*ZC4+ZL2.*ZC3.*ZC4+ZL2.*ZC3.*ZL4+ZC2.*ZC3.*ZL4+ZC2.*ZL3.*ZC4+ZC2.*ZL3.*ZL4+ZC2.*ZL4.*ZC4+ZC2.*ZC3.*ZC4).*Zseq+ZL2.*ZC3.*ZL4.*ZC4+ZL2.*ZL3.*ZC4.*Ra+ZL2.*ZL3.*ZL4.*Ra+ZL2.*ZL3.*ZL4.*ZC4+ZL2.*ZC2.*ZC4.*Ra+ZL2.*ZC2.*ZL4.*Ra+ZL2.*ZC2.*ZL4.*ZC4+ZL2.*ZL4.*ZC4.*Ra+ZL2.*ZC3.*ZC4.*Ra+ZL2.*ZC3.*ZL4.*Ra+ZC2.*ZC3.*ZL4.*Ra+ZC2.*ZC3.*ZL4.*ZC4+ZC2.*ZL3.*ZC4.*Ra+ZC2.*ZL3.*ZL4.*Ra+ZC2.*ZL3.*ZL4.*ZC4+ZC2.*ZL4.*ZC4.*Ra+ZC2.*ZC3.*ZC4.*Ra).*(ZL2.*ZC2.*ZC3.*ZL4.*Ra+ZL2.*ZC2.*ZC3.*ZL4.*ZC4+ZL2.*ZC2.*ZL3.*ZC4.*Ra+ZL2.*ZC2.*ZL3.*ZL4.*Ra+ZL2.*ZC2.*ZL3.*ZL4.*ZC4+ZL2.*ZC2.*ZL4.*ZC4.*Ra+ZL2.*ZC2.*ZC3.*ZC4.*Ra+ZC1.*ZC2.*ZL3.*ZL4.*Ra+ZC1.*ZC2.*ZL3.*ZL4.*ZC4+ZC1.*ZC2.*ZL4.*ZC4.*Ra+ZC1.*ZC2.*ZC3.*ZC4.*Ra+ZC1.*ZL2.*ZC2.*ZC4.*Ra+ZC1.*ZL2.*ZC2.*ZL4.*Ra+ZC1.*ZL2.*ZC2.*ZL4.*ZC4+ZC1.*ZL2.*ZL4.*ZC4.*Ra+ZC1.*ZL2.*ZC3.*ZC4.*Ra+ZC1.*ZL2.*ZC3.*ZL4.*Ra+ZC1.*ZC2.*ZC3.*ZL4.*Ra+ZC1.*ZC2.*ZC3.*ZL4.*ZC4+ZC1.*ZC2.*ZL3.*ZC4.*Ra+ZL1.*ZC2.*ZL4.*ZC4.*Ra+ZL1.*ZC2.*ZC3.*ZC4.*Ra+ZC1.*ZL2.*ZC3.*ZL4.*ZC4+ZC1.*ZL2.*ZL3.*ZC4.*Ra+ZC1.*ZL2.*ZL3.*ZL4.*Ra+ZC1.*ZL2.*ZL3.*ZL4.*ZC4+ZL1.*ZL2.*ZC3.*ZC4.*Ra+ZL1.*ZL2.*ZC3.*ZL4.*Ra+ZL1.*ZC2.*ZC3.*ZL4.*Ra+ZL1.*ZC2.*ZC3.*ZL4.*ZC4+ZL1.*ZC2.*ZL3.*ZC4.*Ra+ZL1.*ZC2.*ZL3.*ZL4.*Ra+ZL1.*ZC2.*ZL3.*ZL4.*ZC4+ZL1.*ZL2.*ZC3.*ZL4.*ZC4+ZL1.*ZL2.*ZL3.*ZC4.*Ra+ZL1.*ZL2.*ZL3.*ZL4.*Ra+ZL1.*ZL2.*ZL3.*ZL4.*ZC4+ZL1.*ZL2.*ZC2.*ZC4.*Ra+ZL1.*ZL2.*ZC2.*ZL4.*Ra+ZL1.*ZL2.*ZC2.*ZL4.*ZC4+ZL1.*ZL2.*ZL4.*ZC4.*Ra+(ZL2.*ZC2.*ZL4.*ZC4+ZL1.*ZC2.*ZC3.*ZL4+ZL1.*ZC2.*ZL3.*ZL4+ZL1.*ZL2.*ZC2.*ZL4+ZL2.*ZC2.*ZC3.*ZL4+ZL2.*ZC2.*ZL3.*ZL4+ZC1.*ZC2.*ZL3.*ZL4+ZC1.*ZC2.*ZC3.*ZL4+ZC1.*ZL2.*ZC2.*ZL4+ZC1.*ZL2.*ZL3.*ZL4+ZC1.*ZL2.*ZC3.*ZL4+ZL1.*ZL2.*ZC2.*ZC4+ZL2.*ZC2.*ZC3.*ZC4+ZL2.*ZC2.*ZL3.*ZC4+ZC1.*ZC2.*ZL3.*ZC4+ZC1.*ZL2.*ZC2.*ZC4+ZC1.*ZL2.*ZL3.*ZC4+ZC1.*ZC2.*ZC3.*ZC4+ZC1.*ZL2.*ZC3.*ZC4+ZL1.*ZL2.*ZC3.*ZC4+ZL1.*ZL2.*ZL3.*ZC4+ZL1.*ZC2.*ZC3.*ZC4+ZL1.*ZC2.*ZL3.*ZC4+ZL1.*ZL2.*ZC3.*ZL4+ZL1.*ZL2.*ZL3.*ZL4+ZC1.*ZC2.*ZL4.*ZC4+ZL1.*ZC2.*ZL4.*ZC4+ZC1.*ZL2.*ZL4.*ZC4+ZL1.*ZL2.*ZL4.*ZC4).*Zseq);
end

modZin = abs(Zin);
fasZin = angle(Zin);
minimoZin = min(modZin);
C = Zinmin - minimoZin;
Ceq = [];