function [modulo,fase] = fBessel(f,arg,tipo,ordem)

w  = 2*pi*f;
f0 = arg(1); f1 = arg(2); f2 = arg(3);
w0 = 2*pi*f0;
w1 = 2*pi*f1;
w2 = 2*pi*f2;
s  = j*w;

if strcmp(tipo,'PB')
    sn = s/w0;
elseif strcmp(tipo,'PF')
    w0 = sqrt(w1*w2);
    B = w2 - w1;
    sn = (s.^2 + w0^2)./(B*s);
else
    sn = w0./s;
end

switch ordem
case 1
    den = sn + 1;
case 2
    den = sn.^2 + sqrt(3)*sn + 1;
case 3
    den = sn.^3 + 2.43288*sn.^2 + 2.46621*sn + 1;
otherwise
    den = sn.^4 + 3.12394*sn.^3 + 4.39155*sn.^2 + 3.20109*sn + 1;
end
modulo = abs(1./den);
fase = angle(1./den);
fase = unwrap(fase);