function [falha,f,s,modHs,modHseq,fasHs,fasHseq,Zs,Zseq,Zser,Zpar] = falante(handle)
falha=0; f=0; s=0; modHs=0; modHseq=0; fasHs=0; fasHseq=0; Zs=0; Zseq=0; Zser=0; Zpar=0;
obj = findobj(handle,'Tag','arqHs');
arq = get(obj,'String');
if isempty(arq) | exist(arq) ~= 2
    errordlg('Arquivo com o SPL do alto-falante no informado ou inexistente','Faltando dado de entrada')
    falha = 1;
    return
end
Fp = fopen(arq,'r');
temp = str2num(fgetl(Fp));
fclose(Fp);
nColunas = size(temp,2);

Fp = fopen(arq,'r');
[dadosHs N] = fscanf(Fp,'%e');
dadosHs = reshape(dadosHs,nColunas,N/nColunas)';

obj = findobj(handle,'Tag','arqZs');
arq = get(obj,'String');
if isempty(arq) | exist(arq) ~= 2
    errordlg('Arquivo com a Zvc do alto-falante no informado ou inexistente','Faltando dado de entrada')
    falha = 1;
    return
end
Fp = fopen(arq,'r');
[dadosZs N] = fscanf(Fp,'%e');
dadosZs = reshape(dadosZs,3,N/3)';
fclose(Fp);

f     = dadosHs(:,1);
s     = j*2*pi*f;
modHs = dadosHs(:,2);
modHs = 10.^(0.05*modHs);
if nColunas == 3
    fasHs = unwrap(dadosHs(:,3)*pi/180);
else
    fasHs = [];
end
modZs = dadosZs(:,2);
fasZs = dadosZs(:,3);
Zs = modZs.*( cos(fasZs*pi/180) + j*sin(fasZs*pi/180) );

obj = findobj(handle,'Tag','Zs1');
Zs1 = get(obj,'Value');
obj = findobj(handle,'Tag','Rs1');
Rs1 = get(obj,'String');
obj = findobj(handle,'Tag','Ls1');
Ls1 = get(obj,'String');
obj = findobj(handle,'Tag','Cs1');
Cs1 = get(obj,'String');
if (Zs1==1) & ( isempty(Rs1)==0 | isempty(Ls1)==0 | isempty(Cs1)==0 )
    if isempty(Rs1)
        Rs1 = 0;
    else
        Rs1 = str2double(Rs1);
    end
    if isempty(Ls1)
        ZLs1 = 0;
    else
        Ls1 = str2double(Ls1)*1e-3;
        ZLs1 = s.*Ls1;
    end
    if isempty(Cs1)
        ZCs1 = 0;
    else
        Cs1 = str2double(Cs1)*1e-6;
        ZCs1 = 1./(s*Cs1);
    end
    Zs1 = Rs1 + ZLs1 + ZCs1;
else
    Zs1 = 0;
end
obj = findobj(handle,'Tag','Zs2');
Zs2 = get(obj,'Value');
obj = findobj(handle,'Tag','Rs2');
Rs2 = get(obj,'String');
obj = findobj(handle,'Tag','Ls2');
Ls2 = get(obj,'String');
obj = findobj(handle,'Tag','Cs2');
Cs2 = get(obj,'String');
obj = findobj(handle,'Tag','RLs2');
RLs2 = get(obj,'String');
if isempty(RLs2)
    RLs2 = 0;
    set(obj,'String','0')
else
    RLs2 = str2double(RLs2);
end
if (Zs2==1) & ( isempty(Rs2)==0 | isempty(Ls2)==0 | isempty(Cs2)==0 )
    if isempty(Rs2)
        Rs2 = inf;
    else
        Rs2 = str2double(Rs2);
    end
    if isempty(Ls2)
        ZLs2 = inf;
    else
        Ls2 = str2double(Ls2)*1e-3;
        ZLs2 = RLs2 + s.*Ls2;
    end
    if isempty(Cs2)
        ZCs2 = inf;
    else
        Cs2 = str2double(Cs2)*1e-6;
        ZCs2 = 1./(s*Cs2);
    end
    Ys2 = 1./Rs2 + 1./ZLs2 + 1./ZCs2;
    Zs2 = 1./Ys2;
else
    Zs2 = 0;
end
Zp1 = RLC(handle,s,'Zp1','Rp1','Lp1','Cp1');
Zp2 = RLC(handle,s,'Zp2','Rp2','Lp2','Cp2');
Zp3 = RLC(handle,s,'Zp3','Rp3','Lp3','Cp3');

Zser = Zs1 + Zs2;
Ypar = 1./Zp1 + 1./Zp2 + 1./Zp3;
if Ypar == 0
    Zeq = Zs;
    Zpar = inf;
else
    Zpar = 1./Ypar;
    Zeq = (Zs.*Zpar)./(Zs+Zpar);
end
Zseq = Zser + Zeq;
Heq = Zeq./(Zeq+Zser);
modHseq = abs(Heq).*modHs;
if isempty(fasHs)
    fasHseq = [];
else
    fasHseq = unwrap(angle(Heq) + fasHs);
end

function Zp = RLC(handle,s,Z,R,L,C)
obj = findobj(handle,'Tag',Z);
Zp = get(obj,'Value');
obj = findobj(handle,'Tag',R);
Rp = get(obj,'String');
obj = findobj(handle,'Tag',L);
Lp = get(obj,'String');
obj = findobj(handle,'Tag',C);
Cp = get(obj,'String');
if (Zp==1) & ( isempty(Rp)==0 | isempty(Lp)==0 | isempty(Cp)==0 )
    if isempty(Rp)
        Rp = 0;
    else
        Rp = str2double(Rp);
    end
    if isempty(Lp)
        ZLp = 0;
    else
        Lp = str2double(Lp)*1e-3;
        ZLp = s.*Lp;
    end
    if isempty(Cp)
        ZCp = 0;
    else
        Cp = str2double(Cp)*1e-6;
        ZCp = 1./(s.*Cp);
    end
    Zp = Rp + ZLp + ZCp;
else
    Zp = inf;
end