function frbw()

handle = gcf;
tag    = get(gcbo,'Tag');
string = get(gcbo,'String');
valor  = str2double(string);

if ~isempty(findstr(string,','))
    errordlg('Utilize "." no lugar de "," para indicar o ponto decimal','Dado de entrada invlido');
    set(gcbo,'String','')
    return
end

switch tag
case {'Rs1' 'Cs1' 'Ls1'}
    sfr = 'fr1';
    sBw = 'Bw1';
    if strcmp(string,'')
        fr = '';
        Bw = '';
    elseif isnan(valor)
        errordlg('Valor digitado deve ser um nmero','Dado de entrada invlido');
        set(gcbo,'String','')
        fr = '';
        Bw = '';
    elseif  valor < 0
        errordlg('Valor negativo','Dado de entrada invlido');
        set(gcbo,'String','')
        fr = '';
        Bw = '';
    else
        [fr,Bw] = calc(handle,'fr1','Bw1','Rs1','Ls1','Cs1');
    end
case {'Rs2' 'Cs2' 'Ls2'}
    sfr = 'fr2';
    sBw = 'Bw2';
    if strcmp(string,'')
        fr = '';
        Bw = '';
    elseif isnan(valor)
        errordlg('Valor digitado deve ser um nmero','Dado de entrada invlido');
        set(gcbo,'String','')
        fr = '';
        Bw = '';
    elseif  valor < 0
        errordlg('Valor negativo','Dado de entrada invlido');
        set(gcbo,'String','')
        fr = '';
        Bw = '';
    else
        [fr,Bw] = calc(handle,'fr2','Bw2','Rs2','Ls2','Cs2');
    end
case {'Rp1' 'Cp1' 'Lp1'}
    sfr = 'fr3';
    sBw = 'Bw3';
    if strcmp(string,'')
        fr = '';
        Bw = '';
    elseif isnan(valor)
        errordlg('Valor digitado deve ser um nmero','Dado de entrada invlido');
        set(gcbo,'String','')
        fr = '';
        Bw = '';
    elseif  valor < 0
        errordlg('Valor negativo','Dado de entrada invlido');
        set(gcbo,'String','')
        fr = '';
        Bw = '';
    else
        [fr,Bw] = calc(handle,'fr3','Bw3','Rp1','Lp1','Cp1');
    end
case {'Rp2' 'Cp2' 'Lp2'}
    sfr = 'fr4';
    sBw = 'Bw4';
    if strcmp(string,'')
        fr = '';
        Bw = '';
    elseif isnan(valor)
        errordlg('Valor digitado deve ser um nmero','Dado de entrada invlido');
        set(gcbo,'String','')
        fr = '';
        Bw = '';
    elseif  valor < 0
        errordlg('Valor negativo','Dado de entrada invlido');
        set(gcbo,'String','')
        fr = '';
        Bw = '';
    else
        [fr,Bw] = calc(handle,'fr4','Bw4','Rp2','Lp2','Cp2');
    end
case {'Rp3' 'Cp3' 'Lp3'}
    sfr = 'fr5';
    sBw = 'Bw5';
    if strcmp(string,'')
        fr = '';
        Bw = '';
    elseif isnan(valor)
        errordlg('Valor digitado deve ser um nmero','Dado de entrada invlido');
        set(gcbo,'String','')
        fr = '';
        Bw = '';
    elseif  valor < 0
        errordlg('Valor negativo','Dado de entrada invlido');
        set(gcbo,'String','')
        fr = '';
        Bw = '';
    else
        [fr,Bw] = calc(handle,'fr5','Bw5','Rp3','Lp3','Cp3');
    end
end

obj = findobj(handle,'Tag',sfr);
set(obj,'String',fr)
obj = findobj(handle,'Tag',sBw);
set(obj,'String',Bw)

function [fr,Bw] = calc(handle,sfr,sBw,sR,sL,sC)
obj = findobj(handle,'Tag',sR);
R = get(obj,'String');
obj = findobj(handle,'Tag',sL);
L = get(obj,'String');
obj = findobj(handle,'Tag',sC);
C = get(obj,'String');
if (~isempty(R) & ~isempty(L) & ~isempty(C))
    R = str2double(R);
    L = str2double(L)*1e-3;
    C = str2double(C)*1e-6;
    fr = 1/(2*pi*sqrt(L*C));
    Q = (2*pi*fr*L)/R;
    Bw = fr/Q;
    fr = num2str(fr);
    Bw = num2str(Bw);
else
    fr = '';
    Bw = '';
end