function graficos(f,P0,modG,fasG,modH,fasH,modHs,modHseq,fasHs,fasHseq,Zs,Zseq,modZin,fasZin,Zser,modZLB,fasZLB,witer,weval,wZin)

figure(1)
[AX,H1,H2] = plotyy(f,modZLB,f,fasZLB,@semilogx);
set(H1,'LineWidth',1.5);
set(H2,'LineWidth',1.5);
set(AX(1),'LineWidth',1.5,'GridLineStyle','-');
set(AX(2),'LineWidth',1.5);
set(gcf,'Name','Look back Impedance','NumberTitle','off')
xlabel('Freqncia (Hz)');
grid on
axes(AX(1))
ylabel('Magnitude (\Omega)');
v1 = axis;
axis tight
v2 = axis;
v2(3) = v1(3); v2(4) = v1(4);
axis(v2)
axes(AX(2))
ylabel('Fase (graus)');
v1 = axis;
axis tight
v2 = axis;
v2(3) = v1(3); v2(4) = v1(4);
axis(v2)

figure(2)
if Zseq == Zs
    traco = semilogx(f,(180/pi)*fasZin,'r',f,(180/pi)*angle(Zs),'k');
    legend('via','alto-falante',0)
else
    traco = semilogx(f,fasZin,'r',f,(180/pi)*angle(Zs),'k',f,(180/pi)*angle(Zseq),'g');
    legend('via','alto-falante','alto-falante corrigida',0)
end
set(gcf,'Name','Fase da impedncia','NumberTitle','off')
set(gca,'LineWidth',1.5,'GridLineStyle','-');
set(traco,'LineWidth',1.5);
xlabel('Freqncia (Hz)'); ylabel('Fase (graus)');
grid on
v1 = axis;
axis tight
v2 = axis;
v2(3) = v1(3); v2(4) = v1(4);
axis(v2)

figure(3)
if Zseq == Zs
    traco = semilogx(f,modZin,'r',f,abs(Zs),'k');
    legend('via','alto-falante',0)
else
    traco = semilogx(f,modZin,'r',f,abs(Zs),'k',f,abs(Zseq),'g');
    legend('via','alto-falante','alto-falante corrigida',0)
end
set(gcf,'Name','Magnitude da impedncia','NumberTitle','off')
set(gca,'LineWidth',1.5,'GridLineStyle','-');
set(traco,'LineWidth',1.5);
xlabel('Freqncia (Hz)'); ylabel('Magnitude (\Omega)');
grid on
v1 = axis;
axis tight
v2 = axis;
v2(3) = v1(3); v2(4) = v1(4);
axis(v2)

figure(4)
if isempty(fasHs)
    traco = semilogx(f,(180/pi)*fasG,'b');
    legend('desejada',0)
elseif Zser == 0
    traco = semilogx(f,(180/pi)*fasG,'b',f,(180/pi)*fasH,'r',f,(180/pi)*fasHs,'k');
    legend('desejada','obtida','alto-falante',0)
else
    traco = semilogx(f,(180/pi)*fasG,'b',f,(180/pi)*fasH,'r',f,(180/pi)*fasHs,'k',f,(180/pi)*fasHseq,'g');
    legend('desejada','obtida','alto-falante','alto-falante corrigida',0)
end
set(gcf,'Name','Fase da presso sonora','NumberTitle','off')
set(gca,'LineWidth',1.5,'GridLineStyle','-');
set(traco,'LineWidth',1.5);
xlabel('Freqncia (Hz)'); ylabel('Fase (graus)');
grid on
v1 = axis;
axis tight
v2 = axis;
v2(3) = v1(3); v2(4) = v1(4);
axis(v2)

figure(5)
if Zser == 0
    traco = semilogx(f,20*log10(P0*modG),'b',f,20*log10(modH),'r',f,20*log10(modHs),'k');
    legend('desejado','obtido','alto-falante',0)
else
    traco = semilogx(f,20*log10(P0*modG),'b',f,20*log10(modH),'r',f,20*log10(modHs),'k',f,20*log10(modHseq),'g');
    legend('desejado','obtido','alto-falante','alto-falante corrigido',0)
end
set(gcf,'Name','SPL','NumberTitle','off')
set(gca,'LineWidth',1.5,'GridLineStyle','-');
set(traco,'LineWidth',1.5);
xlabel('Freqncia (Hz)'); ylabel('SPL');
grid on
v1 = axis;
axis tight
v2 = axis;
v2(3) = v1(3); v2(4) = v1(4);
axis(v2)

if witer == 1
    warndlg('O nmero mximo de iteraes foi alcanado. Se necessrio, aumente o parmetro MaxIter','Aviso')
end
if weval == 1
    warndlg('O nmero mximo de chamadas da funo foi alcanado. Se necessrio, aumente o parmetro MaxFunEval','Aviso')
end
if wZin == 1
    warndlg('Valor mnimo admitido para o Magnitude da impedncia de entrada da via foi desrespeitado','Aviso')
end