function [modZLB,fasZLB] = lookback(s,arqH,X,Zser,Zpar,Rg,RL)
switch arqH
case 'PB06'
    ZL1 = RL(1) + s*X(1);
    Zc = Rg + ZL1;
case 'PB12'
    ZL1 = RL(1) + s*X(1);
    ZC1 = 1./(s*X(2));
    Zc = ((Rg+ZL1).*ZC1)./(Rg+ZL1+ZC1);
case 'PB18'
    ZL1 = RL(1) + s*X(1);
    ZL2 = RL(2) + s*X(2);
    ZC1 = 1./(s*X(3));
    Zc = ((Rg+ZL1).*ZC1)./(Rg+ZL1+ZC1) + ZL2;
case 'PB24'
    ZL1 = RL(1) + s*X(1);
    ZL2 = RL(2) + s*X(2);
    ZC1 = 1./(s*X(3));
    ZC2 = 1./(s*X(4));
    Zca = ((Rg+ZL1).*ZC1)./(Rg+ZL1+ZC1) + ZL2;
    Zc = (Zca.*ZC2)./(Zca+ZC2);
case 'PA06'
    Ra = X(1);
    ZC1 = 1./(s*X(2));
    Zc = Rg + Ra + ZC1;
case 'PA12'
    Ra = X(1);
    ZL1 = RL(1) + s*X(2);
    ZC1 = 1./(s*X(3));
    Zc = Ra + ((Rg+ZC1).*ZL1)./(Rg+ZC1+ZL1);
case 'PA18'
    Ra = X(1);
    ZL1 = RL(1) + s*X(2);
    ZC1 = 1./(s*X(3));
    ZC2 = 1./(s*X(4));
    Zc = Ra + ZC2 + ((Rg+ZC1).*ZL1)./(Rg+ZC1+ZL1);
case 'PA24'
    Ra = X(1);
    ZL1 = RL(1) + s*X(2);
    ZL2 = RL(2) + s*X(3);
    ZC1 = 1./(s*X(4));
    ZC2 = 1./(s*X(5));
    Zca = ZC2 + ((Rg+ZC1).*ZL1)./(Rg+ZC1+ZL1);
    Zc = Ra + (Zca.*ZL2)./(Zca+ZL2);
case 'PF06'
    Ra = X(1);
    ZL1 = RL(1) + s*X(2);
    ZC1 = 1./(s*X(3));
    Zc = Rg + Ra + ZL1 + ZC1;
case 'PF12'
    Ra = X(1);
    ZL1 = RL(1) + s*X(2);
    ZL2 = RL(2) + s*X(3);
    ZC1 = 1./(s*X(4));
    ZC2 = 1./(s*X(5));
    Ya = 1./(Rg+ZL1+ZC1)+ 1./ZL2 + 1./ZC2;
    Zc = Ra + 1./Ya;
case 'PF18'
    Ra = X(1);
    ZL1 = RL(1) + s*X(2);
    ZL2 = RL(2) + s*X(3);
    ZL3 = RL(3) + s*X(4);
    ZC1 = 1./(s*X(5));
    ZC2 = 1./(s*X(6));
    ZC3 = 1./(s*X(7));
    Ya = 1./(Rg+ZL1+ZC1)+ 1./ZL2 + 1./ZC2;
    Zc = Ra + ZL3 + ZC3 + 1./Ya;
otherwise
    Ra = X(1);
    ZL1 = RL(1) + s*X(2);
    ZL2 = RL(2) + s*X(3);
    ZL3 = RL(3) + s*X(4);
    ZL4 = RL(4) + s*X(5);
    ZC1 = 1./(s*X(6));
    ZC2 = 1./(s*X(7));
    ZC3 = 1./(s*X(8));
    ZC4 = 1./(s*X(9));
    Ya = 1./(Rg+ZL1+ZC1)+ 1./ZL2 + 1./ZC2;
    Za = ZL3 + ZC3 + 1./Ya;
    Yb = 1./ZL4 + 1./ZC4 + 1./Za;
    Zc = Ra + 1./Yb;
end

if Zpar ~= inf
    ZLB = ((Zc + Zser).*Zpar)./(Zc + Zser + Zpar);
else
    ZLB = Zc + Zser;
end

modZLB = abs(ZLB);
fasZLB = (180/pi)*angle(ZLB);