function [X,falha,witer,weval,modH,fasH,modZin,fasZin,erro,minZin,modZLB,fasZLB] = otimiza(handle,arq,Y0,f,s,modG,fasG,modHseq,fasHseq,Zseq,Zinmin,LB,UB,RL,W,P0,Zser,Zpar,Rg)

X = 0; falha = 0; witer = 0; weval = 0;
modH = 0; fasH = 0; modZin = 0; fasZin = 0; erro = 0; minZin = 0;
info2.iterations = 0; info2.funcCount = 0;
info4.iterations = 0; info4.funcCount = 0;

obj     = findobj(handle,'Tag','TolX');
TolX    = get(obj,'String');
obj     = findobj(handle,'Tag','TolFun');
TolFun  = get(obj,'String');
obj     = findobj(handle,'Tag','MaxEval');
MaxEval = get(obj,'String');
obj     = findobj(handle,'Tag','MaxIter');
MaxIter = get(obj,'String');
if isempty(TolX) | isempty(TolFun) | isempty(MaxEval) | isempty(MaxIter)
    errordlg('Opo(es) de otimizao no fornecida(s)','Faltando dado(s) de entrada');
    falha = 1;
    return
else
    TolX    = str2double(TolX);
    TolFun  = str2double(TolFun);
    MaxEval = str2double(MaxEval);
    MaxIter = str2double(MaxIter);
end

figcalc = openfig('Calculando');

options = optimset('TolX', TolX, 'TolFun', TolFun, 'MaxFunEvals', MaxEval, 'MaxIter', MaxIter,...
                   'Display', 'off', 'LargeScale', 'off', 'TolCon', 1e-10);

[Y1,erro1,exitflag1,info1] = fminsearch('Fts',Y0,options,arq,s,Zseq,Zinmin,LB,UB,RL,modG,modHseq,fasHseq,W,P0);
[c,ceq,minZin] = feval('Zins',Y1,arq,s,Zseq,Zinmin,LB,UB,RL);
if minZin<Zinmin
    [Y1,erro1,exitflag1,info2] = fmincon('Fts',Y1,[],[],[],[],[],[],'Zins',options,...
                                         arq,s,Zseq,Zinmin,LB,UB,RL,modG,modHseq,fasHseq,W,P0);
end
[Y2,erro2,exitflag2,info3] = fmincon('Fts',Y0,[],[],[],[],-inf,inf,[],options,...
                                     arq,s,Zseq,Zinmin,LB,UB,RL,modG,modHseq,fasHseq,W,P0);
[c,ceq,minZin] = feval('Zins',Y2,arq,s,Zseq,Zinmin,LB,UB,RL);
if minZin<Zinmin
    [Y2,erro2,exitflag2,info4] = fmincon('Fts',Y2,[],[],[],[],[],[],'Zins',options,...
                                         arq,s,Zseq,Zinmin,LB,UB,RL,modG,modHseq,fasHseq,W,P0);
end
[Y3,erro3,exitflag3,info5] = fmincon('Fts',Y0,[],[],[],[],[],[],'Zins',options,...
                                     arq,s,Zseq,Zinmin,LB,UB,RL,modG,modHseq,fasHseq,W,P0);

close(figcalc)
if exitflag1<0 & exitflag2 <0 & exitflag3 <0
    msgbox('A otimizao no foi realizada com sucesso','Fim da otimizao');
    obj = findobj(handle,'Tag','recalcular');
    set(obj,'Enable','off')
    falha = 1;
    return
elseif min([erro1,erro2,erro3]) == erro1
    Y = Y1;
elseif min([erro1,erro2,erro3]) == erro2
    Y = Y2;
else
    Y = Y3;
end

[erro,modH,fasH] = feval('Fts',Y,arq,s,Zseq,Zinmin,LB,UB,RL,modG,modHseq,fasHseq,W,P0);
[c,ceq,minZin,modZin,fasZin] = feval('Zins',Y,arq,s,Zseq,Zinmin,LB,UB,RL);
X = 0.5*(UB + LB) + 0.5*(UB - LB).*sin(Y);
obj = [findobj(handle,'Tag','recalcular'),findobj(handle,'Tag',arq)];
set(obj,'Enable','on')

[modZLB,fasZLB] = lookback(s,arq,X,Zser,Zpar,Rg,RL);

save ArqVar arq X Y LB UB f P0 modG fasG modH fasH modZin fasZin modZLB fasZLB

niter = max([info1.iterations,info2.iterations,info3.iterations,info4.iterations,info5.iterations]);
neval = max([info1.funcCount,info2.funcCount,info3.funcCount,info4.funcCount,info5.funcCount]);
if niter >= options.MaxIter
    witer = 1;
end
if neval >= options.MaxFunEvals
    weval = 1;
end